import { Container } from '@adonisjs/fold';
import { LoggerFactory } from '@adonisjs/logger/factories';
import { RequestFactory } from './request.js';
import { ResponseFactory } from './response.js';
import { HttpContext } from '../src/http_context/main.js';
export class HttpContextFactory {
    #parameters = {};
    #createRequest() {
        return this.#parameters.request || new RequestFactory().create();
    }
    #createResponse() {
        return this.#parameters.response || new ResponseFactory().create();
    }
    #createLogger() {
        return this.#parameters.logger || new LoggerFactory().create();
    }
    merge(params) {
        Object.assign(this.#parameters, params);
        return this;
    }
    create() {
        return new HttpContext(this.#createRequest(), this.#createResponse(), this.#createLogger(), new Container().createResolver());
    }
}
