import { Qs } from '../src/qs.js';
export class QsParserFactory {
    #options = {
        parse: {
            depth: 5,
            parameterLimit: 1000,
            allowSparse: false,
            arrayLimit: 20,
            comma: true,
        },
        stringify: {
            encode: true,
            encodeValuesOnly: false,
            arrayFormat: 'indices',
            skipNulls: false,
        },
    };
    merge(options) {
        Object.assign(this.#options.parse, options.parse);
        Object.assign(this.#options.stringify, options.stringify);
        return this;
    }
    create() {
        return new Qs(this.#options);
    }
}
