import { moduleImporter } from '@adonisjs/fold';
function middlewareReferenceBuilder(name, middleware) {
    const handler = moduleImporter(middleware, 'handle').toHandleMethod();
    return function (...args) {
        return {
            name,
            args: args[0],
            ...handler,
        };
    };
}
export function defineNamedMiddleware(collection) {
    return Object.keys(collection).reduce((result, key) => {
        result[key] = middlewareReferenceBuilder(key, collection[key]);
        return result;
    }, {});
}
