import type { Level } from '@adonisjs/logger/types';
import type { HttpContext } from './http_context/main.js';
import type { HttpError, StatusPageRange, StatusPageRenderer } from './types/server.js';
export declare class ExceptionHandler {
    #private;
    protected debug: boolean;
    protected renderStatusPages: boolean;
    protected statusPages: Record<StatusPageRange, StatusPageRenderer>;
    protected renderers: {
        html: (error: HttpError, ctx: HttpContext) => Promise<void>;
        json: (error: HttpError, ctx: HttpContext) => Promise<void>;
        json_api: (error: HttpError, ctx: HttpContext) => Promise<void>;
    };
    protected reportErrors: boolean;
    protected ignoreExceptions: any[];
    protected ignoreStatuses: number[];
    protected ignoreCodes: string[];
    protected context(ctx: HttpContext): any;
    protected getResponseFormat(ctx: HttpContext): 'html' | 'json' | 'json_api';
    protected getErrorLogLevel(error: HttpError): Level;
    protected isDebuggingEnabled(_: HttpContext): boolean;
    protected shouldReport(error: HttpError): boolean;
    report(error: unknown, ctx: HttpContext): Promise<void>;
    handle(error: unknown, ctx: HttpContext): Promise<any>;
}
