import { createError, Exception } from '@poppinss/utils';
export const E_ROUTE_NOT_FOUND = createError('Cannot %s:%s', 'E_ROUTE_NOT_FOUND', 404);
export const E_CANNOT_LOOKUP_ROUTE = createError('Cannot lookup route "%s"', 'E_CANNOT_LOOKUP_ROUTE', 500);
export const E_HTTP_EXCEPTION = class HttpException extends Exception {
    body;
    static code = 'E_HTTP_EXCEPTION';
    static invoke(body, status, code = 'E_HTTP_EXCEPTION') {
        if (body === null || body === undefined) {
            const error = new this('HTTP Exception', { status, code });
            error.body = 'Internal server error';
            return error;
        }
        if (typeof body === 'object') {
            const error = new this(body.message || 'HTTP Exception', { status, code });
            error.body = body;
            return error;
        }
        const error = new this(body, { status, code });
        error.body = body;
        return error;
    }
};
export const E_HTTP_REQUEST_ABORTED = class AbortException extends E_HTTP_EXCEPTION {
    handle(error, ctx) {
        ctx.response.status(error.status).send(error.body);
    }
};
