import { useReturnValue } from './factories/use_return_value.js';
export function execute(route, resolver, ctx) {
    return route.middleware
        .runner()
        .finalHandler(async () => {
        if (typeof route.handler === 'function') {
            return Promise.resolve(route.handler(ctx)).then(useReturnValue(ctx));
        }
        return route.handler.handle(resolver, ctx).then(useReturnValue(ctx));
    })
        .run(async (middleware, next) => {
        if (typeof middleware === 'function') {
            return middleware(ctx, next);
        }
        return middleware.handle(resolver, ctx, next, middleware.args);
    });
}
