import Macroable from '@poppinss/macroable';
import type { RouteMatcher } from '../types/route.js';
import type { MiddlewareFn, ParsedNamedMiddleware } from '../types/middleware.js';
import { Route } from './route.js';
import { BriskRoute } from './brisk.js';
import { RouteResource } from './resource.js';
import { OneOrMore } from '../types/base.js';
export declare class RouteGroup extends Macroable {
    #private;
    routes: (Route | RouteGroup | RouteResource | BriskRoute)[];
    constructor(routes: (Route | RouteGroup | RouteResource | BriskRoute)[]);
    where(param: string, matcher: RouteMatcher | string | RegExp): this;
    prefix(prefix: string): this;
    domain(domain: string): this;
    as(name: string): this;
    use(middleware: OneOrMore<MiddlewareFn | ParsedNamedMiddleware>): this;
    middleware(middleware: OneOrMore<MiddlewareFn | ParsedNamedMiddleware>): this;
}
