import * as errors from '../../exceptions.js';
export class RouteFinder {
    #routes;
    constructor(routes) {
        this.#routes = routes;
    }
    find(routeIdentifier) {
        return (this.#routes.find(({ name, pattern, handler }) => {
            if (name === routeIdentifier || pattern === routeIdentifier) {
                return true;
            }
            if (typeof handler === 'function') {
                return false;
            }
            return handler.reference === routeIdentifier;
        }) || null);
    }
    findOrFail(routeIdentifier) {
        const route = this.find(routeIdentifier);
        if (!route) {
            throw new errors.E_CANNOT_LOOKUP_ROUTE([routeIdentifier]);
        }
        return route;
    }
    has(routeIdentifier) {
        return !!this.find(routeIdentifier);
    }
}
