import Macroable from '@poppinss/macroable';
import type { Application } from '@adonisjs/application';
import { Route } from './route.js';
import type { ParsedGlobalMiddleware } from '../types/middleware.js';
import type { ResourceActionNames, RouteMatcher, RouteMatchers } from '../types/route.js';
export declare class RouteResource extends Macroable {
    #private;
    routes: Route[];
    constructor(app: Application<any>, routerMiddleware: ParsedGlobalMiddleware[], options: {
        resource: string;
        controller: string;
        globalMatchers: RouteMatchers;
        shallow: boolean;
    });
    only(names: ResourceActionNames[]): this;
    except(names: ResourceActionNames[]): this;
    apiOnly(): this;
    where(key: string, matcher: RouteMatcher | string | RegExp): this;
    tap(callback: (route: Route) => void): this;
    tap(actions: ResourceActionNames | ResourceActionNames[], callback: (route: Route) => void): this;
    params(resources: {
        [resource: string]: string;
    }): this;
    as(name: string, normalizeName?: boolean): this;
}
