import Macroable from '@poppinss/macroable';
import type { Application } from '@adonisjs/application';
import type { Constructor, LazyImport, OneOrMore } from '../types/base.js';
import type { MiddlewareFn, ParsedNamedMiddleware, ParsedGlobalMiddleware } from '../types/middleware.js';
import type { GetControllerHandlers, RouteFn, RouteJSON, RouteMatcher, RouteMatchers, StoreRouteMiddleware } from '../types/route.js';
export declare class Route<Controller extends Constructor<any> = any> extends Macroable {
    #private;
    constructor(app: Application<any>, routerMiddleware: ParsedGlobalMiddleware[], options: {
        pattern: string;
        methods: string[];
        handler: RouteFn | string | [LazyImport<Controller> | Controller, GetControllerHandlers<Controller>?];
        globalMatchers: RouteMatchers;
    });
    where(param: string, matcher: RouteMatcher | string | RegExp): this;
    prefix(prefix: string): this;
    domain(domain: string, overwrite?: boolean): this;
    use(middleware: OneOrMore<MiddlewareFn | ParsedNamedMiddleware>): this;
    middleware(middleware: OneOrMore<MiddlewareFn | ParsedNamedMiddleware>): this;
    as(name: string, prepend?: boolean): this;
    isDeleted(): boolean;
    markAsDeleted(): void;
    getName(): string | undefined;
    getPattern(): string;
    setPattern(pattern: string): this;
    getMiddleware(): StoreRouteMiddleware[][];
    toJSON(): RouteJSON;
}
