import type { ErrorHandler, FinalHandler } from '@poppinss/middleware/types';
import type { Constructor } from './base.js';
import type { QSParserConfig } from './qs.js';
import type { RequestConfig } from './request.js';
import type { ResponseConfig } from './response.js';
import type { HttpContext } from '../http_context/main.js';
export type HttpError = {
    message: string;
    status: number;
    code?: string;
    stack?: string;
    cause?: any;
    messages?: any;
    errors?: any;
    handle?: (...args: any[]) => any;
    report?: (...args: any[]) => any;
};
export interface TestingMiddlewarePipeline {
    finalHandler(handler: FinalHandler): this;
    errorHandler(handler: ErrorHandler): this;
    run(ctx: HttpContext): Promise<any>;
}
export type StatusPageRange = `${number}..${number}`;
export type StatusPageRenderer = (error: HttpError, ctx: HttpContext) => any | Promise<any>;
export type HttpRequestFinishedPayload = {
    ctx: HttpContext;
    duration: [number, number];
};
export type ServerErrorHandler = {
    report: (error: any, ctx: HttpContext) => any;
    handle: (error: any, ctx: HttpContext) => any;
};
export type ErrorHandlerAsAClass = Constructor<ServerErrorHandler>;
export type ServerConfig = RequestConfig & ResponseConfig & {
    useAsyncLocalStorage: boolean;
    qs: QSParserConfig;
};
